CtriLib: MenuBar::Execute changes
Category: CtrlLib Estimated time: 0.00 hour
Target version: Spent time: 0.00 hour
Description

After changes to MenuBar::Execute (r5365) it doesn't work in some cases.

Test case:

1. Open some package from ThelDE (builded after r5365).

2. Right mouse click on some package from packages list and select "Package organizer.." bar.
3. Inside opened "Package organizer" window try to add "New libraries..", for example.

The same "Package organizer" window, but opened from "Project" -> "Package organizer.." bar, allows to add "New libraries..", for
example.

Proposed (temporary) solution is to revert the r5365 changes.

History

#1 - 09/29/2012 01:16 PM - Miroslav Fidler
- Status changed from New to Ready for QA
- Assignee set to Sender Ghost

Thanks, reproduced and fixed. Please confirm (and close).

#2 - 09/29/2012 08:04 PM - Sender Ghost
- Status changed from Ready for QA to Approved

Yes, now it works. Thanks.

#3 - 09/29/2012 09:45 PM - Sender Ghost

- File 332_uppsrc.diff added

- Status changed from Approved to New

- Assignee changed from Sender Ghost to Miroslav Fidler
- % Done changed from 0 to 50

But | would like to propose previous behaviour.

Instead of return case for the same owner, just close the menu and allow to open it again. For example, this allows right mouse click on different packages
inside packages list of ThelDE, without extra mouse click to close the menu.
/redmine/projects/upp/repository/revisions/5365/diff/trunk/uppsrc/CtrlLib/MenuBar.cpp
/redmine/projects/upp/repository/revisions/5394/entry/trunk/uppsrc/CtrlLib/MenuBar.cpp#L562

#4 - 09/30/2012 12:28 AM - Sender Ghost

My patch didn't solve the problem with repeated right mouse click.

Current solution works for the test case, but (new) issue is open for discussion, still.

#5 - 09/30/2012 08:03 AM - Sender Ghost

- File deleted (332_uppsrc.diff)

#6 - 09/30/2012 08:03 AM - Sender Ghost

- File 332_2_uppsrc.diff added

| have added the second patch with possible solution for the (new) issue.

#7 - 09/30/2012 08:38 AM - Sender Ghost

But might be exists the possibility of stack overflow for the solution (second patch), because of possible long recursion.

The previous menu level checks apply in reverse, which accumulate with each new level.

#8 - 09/30/2012 09:44 PM - Miroslav Fidler

Well, the "full" solution would probably had to use some form of PostCallback so that Execute is left before the new Execute is started. Anyway, for now |
consider that sort of quirky, as perhaps things would not behave as one expects (that is, that the menu operation is performed before Execute exits).
#9 - 10/01/2012 08:13 PM - Miroslav Fidler

- Assignee changed from Miroslav Fidler to Sender Ghost

#10 - 10/04/2012 09:09 AM - Sender Ghost

- File 332_3_uppsrc.diff added

- Status changed from New to Patch ready

- Assignee changed from Sender Ghost to Miroslav Fidler
- % Done changed from 50 to 100

| implemented another approach (the third patch), while using destructor with CloseMenu and One container.
At least, this might give another idea how to implement correctly.

#11 - 10/04/2012 09:12 AM - Sender Ghost
- File MenuBarExecute.zip added

Also, there is some kind of simple application to test MenuBar::Execute (for single menu).

#12 - 10/04/2012 09:37 AM - Sender Ghost
- File deleted (332_3_uppsrc.diff)

#13 - 10/04/2012 09:37 AM - Sender Ghost
- File 332_3_uppsrc.diff added

Fixed some typos for third patch.

#14 - 10/04/2012 09:47 AM - Sender Ghost

- File deleted (332_3_uppsrc.diff)

#15 - 10/04/2012 09:48 AM - Sender Ghost
- File 332_3_uppsrc.diff added

#16 - 10/04/2012 11:37 AM - Sender Ghost
With third patch the menu closes without the "tail" of previous menu (this is correct).

But after testing with MenuBarExecute application, | found, that destructors of MenuBar still accumulate, which causes the application to terminate for

some number of executed menu in loop (in my case it was for n >= 985). This is also true for current (r5394) approach, but with many levels.

#17 - 10/07/2012 01:56 PM - Miroslav Fidler
- Status changed from Patch ready to Rejected

Sure, there is no solution to this problem...

Files

332_2_uppsrc.diff 780 Bytes 09/30/2012 Sender Ghost
MenuBarExecute.zip 1.25 KB 10/04/2012 Sender Ghost
332_3_uppsrc.diff 1.33 KB 10/04/2012 Sender Ghost
